// BarcodeScanB.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "BarcodeScan.h"
#include <windows.h>
#include <commctrl.h>
#include <Pkfuncs.h>
#include "bcrctl.h"

#define MAX_LOADSTRING 100
#define BCR_EVENT_SCAN_BARCODE	TEXT("BcrScanBarcodeEvent")

// O[oϐ:
HINSTANCE			g_hInst;			// ݂̃C^[tFCX
HWND				g_hWndCommandBar;	// R}h o[ nh
HANDLE				hNotifyEvent = NULL;
BOOL				bExit = FALSE;
HWND				g_hDlg;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);	// ǉ
void ThreadProc(HWND hWnd);

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// AvP[V̏s܂:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_BARCODESCANB));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_BARCODESCANB));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = 0;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    TCHAR szTitle[MAX_LOADSTRING];		// ^Cg o[ eLXg
    TCHAR szWindowClass[MAX_LOADSTRING];	// C EBhE NX

    g_hInst = hInstance; // O[oϐɃCX^Xi[܂B


    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_BARCODESCANB, szWindowClass, MAX_LOADSTRING);


    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hWnd)
    {
        return FALSE;
    }


    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    if (g_hWndCommandBar)
    {
        CommandBar_Show(g_hWndCommandBar, TRUE);
    }

    return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;
    PAINTSTRUCT ps;
    HDC hdc;
	static HANDLE hThread;
	
    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 
            // Iꂽj[̉:
            switch (wmId)
            {
                case IDM_HELP_ABOUT:
                    DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, About);
                    break;
                case IDM_FILE_EXIT:
                    DestroyWindow(hWnd);
                    break;
                default:
                    return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;
        case WM_CREATE:
            g_hWndCommandBar = CommandBar_Create(g_hInst, hWnd, 1);
            CommandBar_InsertMenubar(g_hWndCommandBar, g_hInst, IDR_MENU, 0);
            CommandBar_AddAdornments(g_hWndCommandBar, 0, 0);

			// Cxg̎擾
			hNotifyEvent = CreateEvent(NULL, FALSE, FALSE, BCR_EVENT_SCAN_BARCODE);
			if(hNotifyEvent == NULL)
			{
				MessageBox(hWnd, _T("ERROR: Cxg̎擾Ɏs܂"), L"Failed" , MB_OK | MB_ICONEXCLAMATION);
				return FALSE;
			}
			ResetEvent(hNotifyEvent);

			// obt@NA
			BCRClearBuffer();

			// Xbh쐬
			hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ThreadProc, (LPVOID)hWnd, 0, NULL);
			if(hThread == NULL)
			{
				MessageBox(hWnd, _T("ERROR: Xbh̍쐬Ɏs܂"), L"Failed" , MB_OK | MB_ICONEXCLAMATION);
				return FALSE;
			}

			// _CAO{bNX쐬
			DialogBox(g_hInst, (LPCTSTR)IDD_DIALOG1, hWnd, DlgProc1);

            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
            // TODO: `R[hɒǉĂ...
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
			CloseHandle(hThread);

            CommandBar_Destroy(g_hWndCommandBar);
            PostQuitMessage(0);
            break;


        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            RECT rectChild, rectParent;
            int DlgWidth, DlgHeight;	// sNZPʂł̃_CAO̕ƍłB
            int NewPosX, NewPosY;

            // o[W_CAO𒆉ɂ悤ƂĂ܂B
            if (GetWindowRect(hDlg, &rectChild)) 
            {
                GetClientRect(GetParent(hDlg), &rectParent);
                DlgWidth	= rectChild.right - rectChild.left;
                DlgHeight	= rectChild.bottom - rectChild.top ;
                NewPosX		= (rectParent.right - rectParent.left - DlgWidth) / 2;
                NewPosY		= (rectParent.bottom - rectParent.top - DlgHeight) / 2;
				
                // o[W{bNXʂ傫ꍇłB 
                if (NewPosX < 0) NewPosX = 0;
                if (NewPosY < 0) NewPosY = 0;
                SetWindowPos(hDlg, 0, NewPosX, NewPosY,
                    0, 0, SWP_NOZORDER | SWP_NOSIZE);
            }

            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if ((LOWORD(wParam) == IDOK) || (LOWORD(wParam) == IDCANCEL))
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return TRUE;

    }
    return (INT_PTR)FALSE;
}

// _CAOvV[W
INT_PTR CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{	
	if(g_hDlg == NULL)
	{
		g_hDlg = hDlg;
	}
	int len;

	switch (msg) {
		case WM_INITDIALOG:
			RECT	rectChild, rectParent;
			int		DlgWidth, DlgHeight;
			POINT	NewPos;

			if (GetWindowRect(hDlg, &rectChild)) {
				GetClientRect(GetParent(hDlg), &rectParent);
				DlgWidth	= rectChild.right  - rectChild.left;
				DlgHeight	= rectChild.bottom - rectChild.top;
				NewPos.x	= (rectParent.right  - rectParent.left - DlgWidth) / 2;
				NewPos.y	= (rectParent.bottom - rectParent.top  - DlgHeight) / 2;

				SetWindowPos (hDlg, 0, NewPos.x, NewPos.y, 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}

			return (INT_PTR)TRUE;

		case WM_CTLCOLORSTATIC:
			if(GetWindowLong( (HWND)lParam, GWL_ID ) == IDC_EDIT_DATA)
			{
				return (BOOL)GetStockObject( WHITE_BRUSH );
			}
			break;

		case WM_COMMAND:
			DWORD time;

			switch(LOWORD(wParam)) {
				case IDOK:
					break;

				case IDC_BUTTON_SCAN:
					SetFocus(GetDlgItem(hDlg, IDC_EDIT_DATA));
					BCRTriggerPress();
					Sleep(100);
					
					BCRGetReadTimeOption(&time);
					if(time == 0)
					{
						Sleep(400);
					}
					BCRTriggerRelease();
					break;
				case IDC_BUTTON_CLEAR:
					SetFocus(GetDlgItem(hDlg, IDC_EDIT_DATA));
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, 0, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)_T(""));
					break;

				default:
					break;
			}
			break;

		case WM_CLOSE:
			bExit = TRUE;
			EndDialog(hDlg, LOWORD(wParam));
			SendMessage(GetParent(hDlg), WM_CLOSE, 0, msg);	// eEBhE閽߂𑗂܂B
			return (INT_PTR)TRUE;

		case WM_BCR_SCAN_NOTIFY:

			switch (lParam) {
				case BCR_READ_GOOD:

					BYTE  rawData[BCR_MAX_DATA_LENGTH];
					TCHAR Data[BCR_MAX_DATA_LENGTH+1];
					DWORD dwLength, Flag;
					size_t wcsLength;

					memset(rawData, 0, sizeof(rawData));
					memset(Data, 0, sizeof(Data));

					if(!BCRGetBarcode(rawData, &dwLength, &Flag)) {
						MessageBox(hDlg, _T("f[^擾Ɏs܂B"), _T("G["), MB_OK);
						return (INT_PTR)TRUE;
					}

					// Chɕϊ
					mbstowcs_s(&wcsLength, Data, BCR_MAX_DATA_LENGTH+1, (char*)rawData, dwLength);
					Data[wcsLength-1] = '\n';
					Data[wcsLength] = NULL;

					// GfBbg{bNXɏo
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, len, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)Data);

					break;

				case BCR_READ_NOT_READY:
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, len, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)_T("***Not Ready***\r\n"));
					break;

				case BCR_READ_NO_DATA:
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, len, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)_T("***No Data***\r\n"));
					break;

				case BCR_READ_TIMEOUT:
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, len, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)_T("***Timeout***\r\n"));
					break;

				case BCR_READ_DISABLED:
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, len, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)_T("***Disabled***\r\n"));
					break;

				case BCR_READ_ABORT:
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, len, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)_T("***Abort***\r\n"));
					break;

				default:
					len = GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_DATA));
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_SETSEL, len, len);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT_DATA), EM_REPLACESEL, 0, (LPARAM)_T("***Error***\r\n"));
					break;
			}

			break;

	}
	return (INT_PTR)FALSE;
}

void ThreadProc(HWND hWnd)
{
	while(!bExit)
	{
		/* CxgVOiԂɂȂ̂ҋ@ */
		switch(WaitForSingleObject(hNotifyEvent, 100))
		{
		case WAIT_TIMEOUT:
			break;
		case WAIT_OBJECT_0:
			if(g_hDlg != NULL)
			{
				SendMessage(g_hDlg, WM_BCR_SCAN_NOTIFY, 0, GetEventData(hNotifyEvent));
			}
			ResetEvent(hNotifyEvent);
			break;
		}
	}

	ExitThread(0);
}
