Public Class Form1
    Private PWC As New Opticon.Sysctl.PowerControl

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If PWC.PowerDownDisableMode Then
            checkBox_PowerDownDisableMode.Checked = True
        Else
            checkBox_PowerDownDisableMode.Checked = False
        End If

        Dim index As Integer
        index = 0

        Select Case PWC.BatteryBacklightTimeout
            Case Opticon.Sysctl.BacklightTimeout_Battery.TEN_SEC
                index = 0
            Case Opticon.Sysctl.BacklightTimeout_Battery.THIRTY_SEC
                index = 1
            Case Opticon.Sysctl.BacklightTimeout_Battery.ONE_MIN
                index = 2
            Case Opticon.Sysctl.BacklightTimeout_Battery.TWO_MIN
                index = 3
            Case Opticon.Sysctl.BacklightTimeout_Battery.THREE_MIN
                index = 4
            Case Opticon.Sysctl.BacklightTimeout_Battery.FOUR_MIN
                index = 5
            Case Opticon.Sysctl.BacklightTimeout_Battery.FIVE_MIN
                index = 6
            Case Opticon.Sysctl.BacklightTimeout_Battery.INDEFINITELY
                index = 7
        End Select
        comboBox_Battery_BacklightTimeout.SelectedIndex = index

        Select Case PWC.ACBacklightTimeout
            Case Opticon.Sysctl.BacklightTimeout_AC.ONE_MIN
                index = 0
            Case Opticon.Sysctl.BacklightTimeout_AC.TWO_MIN
                index = 1
            Case Opticon.Sysctl.BacklightTimeout_AC.THREE_MIN
                index = 2
            Case Opticon.Sysctl.BacklightTimeout_AC.FOUR_MIN
                index = 3
            Case Opticon.Sysctl.BacklightTimeout_AC.FIVE_MIN
                index = 4
            Case Opticon.Sysctl.BacklightTimeout_AC.SIX_MIN
                index = 5
            Case Opticon.Sysctl.BacklightTimeout_AC.SEVEN_MIN
                index = 6
            Case Opticon.Sysctl.BacklightTimeout_AC.EIGHT_MIN
                index = 7
            Case Opticon.Sysctl.BacklightTimeout_AC.NINE_MIN
                index = 8
            Case Opticon.Sysctl.BacklightTimeout_AC.TEN_MIN
                index = 9
            Case Opticon.Sysctl.BacklightTimeout_AC.INDEFINITELY
                index = 10
        End Select
        comboBox_AC_BacklightTimeout.SelectedIndex = index
    End Sub

    Private Sub checkBox_PowerDownDisableMode_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkBox_PowerDownDisableMode.CheckStateChanged
        If checkBox_PowerDownDisableMode.Checked Then
            PWC.PowerDownDisableMode = True
        Else
            PWC.PowerDownDisableMode = False
        End If
    End Sub

    Private Sub button_PowerDownResume_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_PowerDownResume.Click
        PWC.PowerDown(Opticon.Sysctl.OnMode.Resume)
    End Sub

    Private Sub button_PowerDownReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_PowerDownReset.Click
        PWC.PowerDown(Opticon.Sysctl.OnMode.Reset)
    End Sub

    Private Sub comboBox_Battery_BacklightTimeout_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_Battery_BacklightTimeout.SelectedIndexChanged
        Select Case comboBox_Battery_BacklightTimeout.SelectedIndex
            Case 0
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.TEN_SEC
            Case 1
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.THIRTY_SEC
            Case 2
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.ONE_MIN
            Case 3
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.TWO_MIN
            Case 4
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.THREE_MIN
            Case 5
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.FOUR_MIN
            Case 6
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.FIVE_MIN
            Case 7
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.TEN_SEC
            Case 8
                PWC.BatteryBacklightTimeout = Opticon.Sysctl.BacklightTimeout_Battery.INDEFINITELY
        End Select
    End Sub

    Private Sub comboBox_AC_BacklightTimeout_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles comboBox_AC_BacklightTimeout.SelectedIndexChanged
        Select Case comboBox_AC_BacklightTimeout.SelectedIndex
            Case 0
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.ONE_MIN
            Case 1
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.TWO_MIN
            Case 2
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.THREE_MIN
            Case 3
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.FOUR_MIN
            Case 4
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.FIVE_MIN
            Case 5
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.SIX_MIN
            Case 6
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.SEVEN_MIN
            Case 7
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.EIGHT_MIN
            Case 8
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.NINE_MIN
            Case 9
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.TEN_MIN
            Case 10
                PWC.ACBacklightTimeout = Opticon.Sysctl.BacklightTimeout_AC.INDEFINITELY
        End Select
    End Sub
End Class
